@echo OFF
rem  * *******************************************************************
rem  *               NXCSYSE1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   - Map File Name via Micro Focus Functions.
rem  * Author - SimoTime Technologies
rem  * Date   - January 24, 1996
rem  *
rem  * The process will execute the first of two COBOL programs. The
rem  * first COBOL program will get a parameter from the command line
rem  * and then use the parameter to set an environment variable.
rem  * The first COBOL program will then call a second COBOL program
rem  * that will use the environment variable to map the COBOL file
rem  * name to a fully qualified PC file name. The file will then be
rem  * read and the records displayed to the screen.
rem  *
rem  * *******************************************************************
rem  *
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
     set CmdName=NxcSysE1
     call ..\Env1BASE %CmdName%
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting JobName %CmdName%"
rem  *
rem  * Step 1, Create a New Test File...
     set TestFile=%BaseLib1%\DataLibA\Txt1\NXCDB080.TXT
     if exist %TestFile% del %TestFile%
rem  *
     call SimoNOTE "%CmdName% Create the ASCII/Text File..."
     echo This is Record-001... >  %TestFile%
     echo This is Record-002... >> %TestFile%
     echo This is Record-003... >> %TestFile%
     echo This is Record-004... >> %TestFile%
     echo This is Record-005... >> %TestFile%
rem  *
rem  * *******************************************************************
rem  * Step 2, Pass File name via Command Line Parameter
rem  *
     run  NXCSYSC1 %TestFile%
     if not ERRORLEVEL = 0 set JobStatus=0001
     if not %JobStatus% == 0000 goto :EojNok
rem  *
:EojAok
     call SimoNOTE "Finished JobName %CmdName%, Job Status is %JobStatus%"
     goto :End
:EojNok
     call SimoNOTE "ABENDING JobName %CmdName%, Job Status is %JobStatus%"
:End
     call SimoNOTE "Conclude SysLog is %SYSLOG%"
     if not "%1" == "nopause" pause
